<template>
     <div class="row">
    
        <div v-for="(post, index) in computedPosts" :key="index" class="col-12 text-center   mx-0 px-0 post-block">
          <!-- Post content -->
            <div  v-if="post.postType === 'embed'" v-html="post.embed" class="embed-responsive embed-responsive-16by9 post-type-embed"></div>
            <div v-if="post.postType === 'redditvideo'" class="embed-responsive embed-responsive-16by9 bg-super-dark-l-10 post-type-video">
              <video :src="post.url" controls :poster="post.poster"></video>
            </div>
            <div v-if="post.postType == 'image'" class="post-type-image">
              <img :src="post.url" :width="post.width" :height="post.height" class="img-fluid"/>
            </div>
            <div v-if="post.postType == 'text'" class="p-5 post-type-text text-left">
              <h3 class="text-light">{{post.title}}</h3>
              <p v-html="post.bodyText" class="text-muted"></p>
            </div>
            <!-- Post info -->
            <div class="mt-2">
              <p><a target="blank" :href="'https://www.reddit.com' + post.permalink" class="text-white">{{post.title}} <br> ({{post.numComments}} comments)</a> </p>
            </div>
          </div>
   

        <div id="posts-end"></div>
 
    </div>
</template>

<script>
import {eventBus} from '../main'

export default {
  name: 'Listing',
  props: ['posts', 'subreddits'],
  data () {
    return {
      
    }
  },
  methods: {
    removeSubreddit (subreddit) {
      eventBus.$emit('deleteSubreddit', {subreddit})
    }
  },
  created(){
  },
  computed:{
    computedPosts () {
      let posts = []
      let htmlDecode = (input) => {
        var doc = new DOMParser().parseFromString(input, "text/html");
        return doc.documentElement.textContent;
      }
      this.posts.forEach(post =>{
        let p = post.data,
            d = ['youtube.com','youtu.be', 'gfycat.com', 'imgur.com', 'twitter.com']
          if (!p.stickied) {
            // videos
            if(d.includes(p.domain) && p.media !== null){
                 posts.push({
                  postType: 'embed',
                  embed: htmlDecode(p.media.oembed.html),
                  permalink: p.permalink,
                  title: p.title,
                  numComments: p.num_comments
                })
            }
            else if(p.domain === 'v.redd.it' && p.media.reddit_video){
                posts.push({
                  postType: 'redditvideo',
                  url: p.media.reddit_video.fallback_url,
                  permalink: p.permalink,
                  title: p.title,
                  numComments: p.num_comments,
                  poster: htmlDecode(p.preview.images[0].source.url)
                })
            }
            else if(p.preview){
              let attr = p.preview.images[0].source;
              posts.push({
                postType: 'image',
                url:  p.url.endsWith('.gif') ? p.url : htmlDecode(attr.url),
                width: attr.width,
                height: attr.height,
                permalink: p.permalink,
                title: p.title,
                numComments: p.num_comments
              })
            }
            else {
              posts.push({
                postType: 'text',
                permalink: p.permalink,
                title: p.title,
                bodyText: p.selftext,
                numComments: p.num_comments,
              })
            }
          }
      })
      return posts
    }
  }
}
</script>
<style lang="scss">
  @import '../styles/components/listing';
</style>
